﻿<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
if  (!empty($_POST['add_link'])) {
	if ( !isset( $_POST['ffp_nonce'] ) OR !wp_verify_nonce( $_POST['ffp_nonce'], 'ffp_nonce_action' ) ) exit;
	
	$add_link = sanitize_text_field($_POST['add_link']);
	$remove_link = sanitize_text_field($_POST['remove_link']);
	$font_awesome = sanitize_text_field($_POST['font_awesome']);
	$no_fav = sanitize_text_field($_POST['no_fav']);
	$hide_fav = sanitize_text_field($_POST['hide_fav']);
	$fav_icon = sanitize_text_field($_POST['fav_icon']);
	update_option( 'ffp_add', $add_link, 'yes' );
	update_option( 'ffp_remove', $remove_link, 'yes' );
	update_option( 'ffp_font_awesome', $font_awesome, 'yes' );
	update_option( 'ffp_no', $no_fav, 'yes' );
	update_option( 'ffp_hide', $hide_fav, 'yes' );
	update_option( 'ffp_icon', $fav_icon, 'yes' );
	echo '<div id="message" class="updated notice notice-success is-dismissible"><p>Saved.</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Hide.</span></button></div>';
}
?>
<h2>Settings</h2>
<form method="post">
	<table cellspacing="10" cellpadding="10">
		<tr>
			<td style="vertical-align: top;">
				<label for="font_awesome">Include fontawesome.css?</label>
			</td>
			<td>
				<input name="font_awesome" value="checked" type="checkbox" <?php echo get_option( 'ffp_font_awesome' );?>>
			</td>

		</tr>
		<tr>
			<td style="vertical-align: top;">
				<label for="add_link">Text for Add link:</label>
			</td>
			<td colspan="2">
				<input type="text" size="50" name="add_link" value="<?php echo get_option( 'ffp_add' );?>"/>
			</td>
		</tr>
		<tr>
			<td style="vertical-align: top;">
				<label for="remove_link">Text for Remove link:</label>
			</td>
			<td colspan="2">
				<input type="text" size="50" name="remove_link" value="<?php echo get_option( 'ffp_remove' );?>"/>
			</td>
		</tr>
		<tr>
			<td style="vertical-align: top;">
				<label for="no_fav">Text for 'Not found posts':</label>
			</td>
			<td colspan="2">
				<input type="text" size="50" name="no_fav" value="<?php echo get_option( 'ffp_no' );?>"/>
			</td>
		</tr>
		<tr>
		<tr>
			<td style="vertical-align: top;">
				<label for="fav_icon">Favorite post icon:</label>
			</td>
			<td>
				<input type="radio" name="fav_icon" value="heart" <?php if (get_option( 'ffp_icon' ) == 'heart') echo 'checked';?>><i class="fa fa-heart" aria-hidden="true"></i><br>
				<input type="radio" name="fav_icon" value="thumb" <?php if (get_option( 'ffp_icon' ) == 'thumb') echo 'checked';?>> <i class="fa fa-thumbs-up" aria-hidden="true"></i><br>
				<input type="radio" name="fav_icon" value="star" <?php if (get_option( 'ffp_icon' ) == 'star') echo 'checked';?>> <i class="fa fa-star" aria-hidden="true"></i>
			</td>
        <?php wp_nonce_field( 'ffp_nonce_action', 'ffp_nonce' ); ?>
		</tr>
			<td colspan="2">
				<input class="button button-primary" type="submit" name="submit" value="Submit"/>
			</td>
		</tr>
	</table>
</form>
<h2>Help</h2>