<?php

/**
 *
 *
 * @wordpress-plugin
 * Plugin Name:       FNS Favorite post
 * Plugin URI:        
 * Description:       Favorite post for yout blog.
 * Version:           1.0.0
 * Author:            FullNet servis
 * Author URI:        http://full-net.cz/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       fns-favorite-post
 * Domain Path:       
 */

// If this file is called directly, abort.

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

define('FFP_DIR', plugin_dir_path(__FILE__));
define('FFP_URL', plugin_dir_url(__FILE__));

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'ffp_action_links' );
function ffp_action_links( $links ) {
   $links[] = '<a href="'. esc_url( get_admin_url(null, 'options-general.php?page=favorite-post') ) .'">Settings</a>';
   return $links;
}

add_option( 'ffp_font_awesome', '1', '', 'yes' ); 
add_option( 'ffp_add', 'Add post to favorite', '', 'yes' ); 
add_option( 'ffp_remove', 'Remove post from favorite', '', 'yes' );
add_option( 'ffp_no', 'Not found.', '', 'yes' );
add_option( 'ffp_hide', '0', '', 'yes' );
add_option( 'ffp_icon', 'heart', '', 'yes' );
add_option( 'ffp_version', '1.0', '', 'yes' ); 
add_option( 'ffp_posttype', array(), '', 'yes' ); 


add_action( 'admin_menu', 'ffp_admin_menu' );
function ffp_admin_menu() {
	add_options_page( 'FNS Favorite posts','FNS Favorite posts','manage_options','fns-favorite-post','ffp_plugin_page');
}

function ffp_plugin_page()
{
    global $title;

    print '<div class="wrap">';
    print "<h1>$title</h1>";
	if (!current_user_can('manage_options')) {
	echo 'ERROR: You do not have permission for this page.';
	}
	else {
	$file = FFP_DIR . "ffp-admin-page.php";
    include_once($file);
	}
	print '</div>';
    
}

function ffp_custom_styles() {
	if (get_option( 'ffp_font_awesome' ) == 'checked'){
    	wp_enqueue_style( 'FFP-font-awesome-CSS', FFP_URL . 'css/font-awesome.min.css' );
		}
	wp_enqueue_style( 'FFP-font-CSS', FFP_URL . 'ffp.css' );
	wp_enqueue_script( 'FFP-JS', FFP_URL . 'ffp.js',  array( 'jquery' ) );
	wp_localize_script( 'FFP-JS', 'my_ajax_url',
            array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
	wp_localize_script( 'FFP-JS', 'fav',
            array( 'add' => get_option( 'ffp_add' ), 'remove' => get_option( 'ffp_remove' ) ) );
	if (get_option( 'ffp_icon' ) == 'heart') {
		$iconthin = 'fa-heart-o'; $iconfull = 'fa-heart';
		wp_localize_script( 'FFP-JS', 'icon',
            array( 'thin' => 'fa-heart-o', 'full' => 'fa-heart' ) );
	}
	elseif (get_option( 'ffp_icon' ) == 'star') {
		$iconthin = 'fa-star-o'; $iconfull = 'fa-star';
		wp_localize_script( 'FFP-JS', 'icon',
            array( 'thin' => 'fa-star-o', 'full' => 'fa-star' ) );
	}
	else {
		$iconthin = 'fa-thumbs-o-up'; $iconfull = 'fa-thumbs-up';
		wp_localize_script( 'FFP-JS', 'icon',
            array( 'thin' => 'fa-thumbs-o-up', 'full' => 'fa-thumbs-up' ) );
	}
}
add_action( 'wp_enqueue_scripts', 'ffp_custom_styles' );

add_action( 'admin_enqueue_scripts', 'ffp_font_awesome_to_admin' );
    function ffp_font_awesome_to_admin() {
        if ($_GET['page'] == 'fns-favorite-post') wp_enqueue_style( 'font-awesome', FFP_URL . 'css/font-awesome.min.css' );
    }

function ffp_link ($favelem = 'div'){
	if (get_option( 'ffp_icon' ) == 'heart') {
		$iconthin = 'fa-heart-o'; $iconfull = 'fa-heart';
	}
	elseif (get_option( 'ffp_icon' ) == 'star') {
		$iconthin = 'fa-star-o'; $iconfull = 'fa-star';
	}
	else {
		$iconthin = 'fa-thumbs-o-up'; $iconfull = 'fa-thumbs-up';
	}
	$cook = $_COOKIE['ffp_favorit']; if (empty($cook)) $cook = array();
	if (in_array(get_the_ID(), $cook)){
		$state = 'unfav';
		$icon = $iconfull;
		$linktext = get_option( 'ffp_remove' );
	}  else {
		$state = 'fav';
		$icon = $iconthin;
		$linktext = get_option( 'ffp_add' );
	}
    echo '<'.$favelem.' class="favhover '.$state.'" data-id="'.get_the_ID().'"><i class="fa '.$icon.' fa-lg" aria-hidden="true"></i> <span>'.$linktext.'</span></'.$favelem.'>';
}


// Creating the widget 
class ffp_widget extends WP_Widget {
function __construct() {
parent::__construct(
// Base ID of your widget
'ffp_widget', 

// Widget name will appear in UI
__('FNS Favorite post', 'ffp_widget_domain'), 

// Widget description
array( 'description' => __( 'Favorite posts widget.', 'ffp_widget_domain' ), ) 
);
}

// Creating widget front-end
// This is where the action happens
public function widget( $args, $instance ) {
$title = apply_filters( 'widget_title', $instance['title'] );
// before and after widget arguments are defined by themes
echo $args['before_widget'];
if ( ! empty( $title ) )
echo $args['before_title'] . $title . $args['after_title'];
$number = $this->number;
$posttype = get_option('ffp_posttype');
$cur_posttype = $posttype['widget'.$number];
$posttype_array = explode(',', $posttype['widget'.$number]);
$hidestatus = $posttype['widgethide'.$number];

// This is where you run the code and display the output
echo '<div class="favpost" data-type="'.$cur_posttype.'" data-hide="'.$hidestatus.'" data-number="'.$number.'">';
ffp_list($posttype_array, $hidestatus, $number);
echo '</div>';
echo $args['after_widget'];
}
		
// Widget Backend 
public function form( $instance ) {
if ( isset( $instance[ 'title' ] ) ) {
$title = $instance[ 'title' ];
}
else {
$title = __( 'Your favorite posts', 'ffp_widget_domain' );
}
// Widget admin form
?>
<?php 
	$number = $this->number;
	$posttype_array = get_option('ffp_posttype');
	if (isset($_POST['post_type']) AND current_user_can('edit_theme_options')) {
		$posttype = sanitize_text_field( $_POST['post_type'] );
		$hidewidget = sanitize_text_field($_POST['hidewidget'] );
		$new_posttype = array ('widget'.$number => $posttype, 'widgethide'.$number => $hidewidget);
		$merge_array = array_merge( $posttype_array, $new_posttype );
		update_option( 'ffp_posttype', $merge_array, 'yes' );
		$posttype_array = get_option('ffp_posttype');
	}
	$hidevalue = get_option('ffp_posttype');
?>
<p>
<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
<label for="post_type">Post types:</label> 
<input class="widefat" id="post_type" name="post_type" type="text" value="<?php echo $posttype_array['widget'.$number];?>" />
<label for="post_type">Hide if empty?</label> 
<input class="widefat" id="hidewidget" name="hidewidget" type="checkbox" value="checked"  <?php echo $hidevalue['widgethide'.$number];?>/>
</p>
<?php 
}
	
// Updating widget replacing old instances with new
public function update( $new_instance, $old_instance ) {
$instance = array();
$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
return $instance;
}
} // Class wpb_widget ends here

// Register and load the widget
function ffp_load_widget() {
	register_widget( 'ffp_widget' );
}
add_action( 'widgets_init', 'ffp_load_widget' );

/*fav list*/
function ffp_list($posttype_array, $hidestatus, $number){	
	$favcook = $_COOKIE['ffp_favorit'];
	$i == 0;
	if (empty($favcook)) {
	}
	else {
	$output .= '<div class="favlist">';
   	$output .= '<ul>';
    foreach ($favcook as &$favitem) {
	if (in_array(get_post_type( $favitem ), $posttype_array) OR empty($posttype_array[0])){
		$output .= '<li><a href="'.get_permalink($favitem).'">'.get_the_title( $favitem).'</a> <i data-id="'.$favitem.'" class="unfav fa fa-times-circle-o" aria-hidden="true"></i></li>';
		$i++;
		}
	}
   	$output .= '</ul>';
    $output .= '</div>';
	
    }
	echo $output;
	if ($i == 0 AND $hidestatus == 'checked') {
		echo '<style> #ffp_widget-'.$number.' {display:none}</style>';
	}
	if ($i == 0 AND $hidestatus != 'checked') {
		echo '<em>'.get_option( 'ffp_no' ).'</em>';
	}
}

/*AJAX*/
function ffp_add() {
    if ( isset($_REQUEST) ) {
		$favID = intval($_REQUEST['favID']);
		$cookie = 'ffp_favorit['.$favID.']';
		setcookie($cookie, $favID, time() + 60*60*24*30, '/');
		$_COOKIE['ffp_favorit'][$favID] = $favID;
    }
	print_r($_COOKIE['ffp_favorit']);
   die();
}
add_action( 'wp_ajax_ffp_add', 'ffp_add' );
add_action( 'wp_ajax_nopriv_ffp_add', 'ffp_add' );

function ffp_rem() {
    if ( isset($_REQUEST) ) {
		$favID = intval($_REQUEST['favID']);
		$cookie = 'ffp_favorit['.$favID.']';
		setcookie($cookie, null, -1, '/');
    	unset($_COOKIE['ffp_favorit'][$favID]);
    }
	print_r($_COOKIE['ffp_favorit']);
   die();
}
add_action( 'wp_ajax_ffp_rem', 'ffp_rem' );
add_action( 'wp_ajax_nopriv_ffp_rem', 'ffp_rem' );

function ffp_loadwidget() {
	if ( isset($_REQUEST) ) {
	$posttype_array = explode(',', $_REQUEST['data_type']);
	$number = intval($_REQUEST['data_number']);
	$hide = sanitize_text_field($_REQUEST['data_hide']);
	ffp_list($posttype_array, $hide, $number);
	}
	die();
}
add_action( 'wp_ajax_ffp_loadwidget', 'ffp_loadwidget' );
add_action( 'wp_ajax_nopriv_ffp_loadwidget', 'ffp_loadwidget' );